From dcf30f8225829735e225aa76d1d03bdc372b1de1 Mon Sep 17 00:00:00 2001
From: Matthew Macy <kmacy@freebsd.org>
Date: Fri, 7 Nov 2014 22:00:41 -0800
Subject: [PATCH] initial stab at compiling COMPAT_MACH

(cherry picked from commit 4b74a6db7b2917232414ae57bd2f0cc0c8b443e9)
Signed-off-by: Scott K <scott@ixsystems.com>
---
 sys/compat/mach/Makefile              |  27 +-
 sys/compat/mach/init_sysent.c         |   5 +
 sys/compat/mach/mach_bootstrap.c      |  17 +-
 sys/compat/mach/mach_bootstrap.h      |   2 +-
 sys/compat/mach/mach_clock.c          |  36 +-
 sys/compat/mach/mach_clock.h          |   2 +-
 sys/compat/mach/mach_errno.c          |   4 +-
 sys/compat/mach/mach_errno.h          |   2 +-
 sys/compat/mach/mach_exception.c      |  95 ++--
 sys/compat/mach/mach_exception.h      |   6 +-
 sys/compat/mach/mach_exec.c           |  36 +-
 sys/compat/mach/mach_exec.h           |  22 +-
 sys/compat/mach/mach_host.c           |  25 +-
 sys/compat/mach/mach_host.h           |   2 +-
 sys/compat/mach/mach_iokit.c          | 111 +++--
 sys/compat/mach/mach_iokit.h          |   2 +-
 sys/compat/mach/mach_message.c        | 176 ++++----
 sys/compat/mach/mach_message.h        |  24 +-
 sys/compat/mach/mach_misc.c           |  74 ++--
 sys/compat/mach/mach_notify.c         |  28 +-
 sys/compat/mach/mach_notify.h         |   8 +-
 sys/compat/mach/mach_port.c           | 124 +++---
 sys/compat/mach/mach_port.h           |  18 +-
 sys/compat/mach/mach_proto.h          | 276 ++++++++++++
 sys/compat/mach/mach_semaphore.c      |  61 ++-
 sys/compat/mach/mach_semaphore.h      |   5 +-
 sys/compat/mach/mach_services.c       |   1 -
 sys/compat/mach/mach_services.h       |   1 -
 sys/compat/mach/mach_services_names.c |   1 -
 sys/compat/mach/mach_syscall.h        | 136 ++----
 sys/compat/mach/mach_syscallargs.h    | 258 -----------
 sys/compat/mach/mach_syscalls.c       | 281 ++++++------
 sys/compat/mach/mach_sysctl.c         |   3 +-
 sys/compat/mach/mach_sysctl.h         |   2 +-
 sys/compat/mach/mach_sysent.c         | 407 ++++++-----------
 sys/compat/mach/mach_task.c           |  99 +++--
 sys/compat/mach/mach_task.h           |   2 +-
 sys/compat/mach/mach_thread.c         |  61 ++-
 sys/compat/mach/mach_thread.h         |  10 +-
 sys/compat/mach/mach_types.h          |   8 +-
 sys/compat/mach/mach_vm.c             | 216 +++++----
 sys/compat/mach/mach_vm.h             |   6 +-
 sys/compat/mach/makemachservices.sh   |  20 +-
 sys/compat/mach/syscalls.c            |   5 +
 sys/compat/mach/syscalls.conf         |  10 +-
 sys/compat/mach/syscalls.master       | 301 ++++++-------
 sys/compat/mach/systrace_args.c       | 804 ++++++++++++++++++++++++++++++++++
 sys/kern/kern_sig.c                   |  26 +-
 sys/sys/signal.h                      |  15 +
 49 files changed, 2223 insertions(+), 1638 deletions(-)
 create mode 100644 sys/compat/mach/init_sysent.c
 create mode 100644 sys/compat/mach/mach_proto.h
 delete mode 100644 sys/compat/mach/mach_syscallargs.h
 create mode 100644 sys/compat/mach/syscalls.c
 create mode 100644 sys/compat/mach/systrace_args.c

diff --git a/sys/compat/mach/Makefile b/sys/compat/mach/Makefile
index 7cc43a8..bbc9ce0 100644
--- a/sys/compat/mach/Makefile
+++ b/sys/compat/mach/Makefile
@@ -1,16 +1,17 @@
-#	$NetBSD: Makefile,v 1.7 2005/12/11 12:20:20 christos Exp $
+# Makefile for syscall tables
+#
+# $FreeBSD$
 
-SYSCALL_DEP=	syscalls.conf syscalls.master ../../kern/makesyscalls.sh
-SYSCALL_OBJS=	mach_sysent.c mach_syscalls.c mach_syscall.h mach_syscallargs.h
-MACH_DEP=	mach_services.master makemachservices.sh
-MACH_OBJ=	mach_services.c mach_services.h mach_services_names.c
+all:
+	@echo "make sysent only"
 
-all:	${SYSCALL_OBJS} ${MACH_OBJ}
+sysent:  mach_sysent.c mach_syscall.h mach_proto.h mach_syscalls.c mach_systrace_args.c
 
-.include <bsd.sys.mk>		# for HOST_SH
-
-${SYSCALL_OBJS}: ${SYSCALL_DEP}
-	${HOST_SH} ../../kern/makesyscalls.sh syscalls.conf syscalls.master
-
-${MACH_OBJ}: ${MACH_DEP}
-	${HOSH_SH} ./makemachservices.sh
+mach_sysent.c mach_syscall.h mach_proto.h mach_syscalls.c mach_systrace_args.c: \
+		../../kern/makesyscalls.sh syscalls.master syscalls.conf
+	-mv -f mach_sysent.c mach_sysent.c.bak
+	-mv -f mach_syscall.h mach_syscall.h.bak
+	-mv -f mach_proto.h mach_proto.h.bak
+	-mv -f mach_syscalls.c mach_syscalls.c.bak
+	-mv -f mach_systrace_args.c mach_systrace_args.c.bak
+	sh ../../kern/makesyscalls.sh syscalls.master syscalls.conf
diff --git a/sys/compat/mach/mach_bootstrap.c b/sys/compat/mach/mach_bootstrap.c
index e40c488..5c21f7d 100644
--- a/sys/compat/mach/mach_bootstrap.c
+++ b/sys/compat/mach/mach_bootstrap.c
@@ -1,5 +1,3 @@
-/*	$NetBSD: mach_bootstrap.c,v 1.14 2008/04/28 20:23:44 martin Exp $ */
-
 /*-
  * Copyright (c) 2002-2003 The NetBSD Foundation, Inc.
  * All rights reserved.
@@ -30,14 +28,18 @@
  */
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: mach_bootstrap.c,v 1.14 2008/04/28 20:23:44 martin Exp $");
+__FBSDID("$FreeBSD$");
 
-#include <sys/types.h>
 #include <sys/param.h>
+#include <sys/types.h>
+#include <sys/kernel.h>
+#include <sys/malloc.h>
+
 #include <sys/systm.h>
 #include <sys/signal.h>
 #include <sys/proc.h>
 
+
 #include <compat/mach/mach_types.h>
 #include <compat/mach/mach_message.h>
 #include <compat/mach/mach_port.h>
@@ -45,12 +47,15 @@ __KERNEL_RCSID(0, "$NetBSD: mach_bootstrap.c,v 1.14 2008/04/28 20:23:44 martin E
 #include <compat/mach/mach_errno.h>
 #include <compat/mach/mach_services.h>
 
+MALLOC_DEFINE(M_MACH, "mach", "mach compatibility subsystem");
+
+
 int
 mach_bootstrap_look_up(struct mach_trap_args *args)
 {
 	mach_bootstrap_look_up_request_t *req = args->smsg;
 	mach_bootstrap_look_up_reply_t *rep = args->rmsg;
-	struct lwp *l = args->l;
+	struct thread *td = args->td;
 	size_t *msglen = args->rsize;
 	const char service_name[] = "lookup\021"; /* XXX Why */
 	int service_name_len;
@@ -65,7 +70,7 @@ mach_bootstrap_look_up(struct mach_trap_args *args)
 		return mach_msg_error(args, EINVAL);
 	*msglen = len;
 
-	mr = mach_right_get(NULL, l, MACH_PORT_TYPE_DEAD_NAME, 0);
+	mr = mach_right_get(NULL, td, MACH_PORT_TYPE_DEAD_NAME, 0);
 
 	mach_set_header(rep, req, *msglen);
 
diff --git a/sys/compat/mach/mach_bootstrap.h b/sys/compat/mach/mach_bootstrap.h
index b798ace..536f576 100644
--- a/sys/compat/mach/mach_bootstrap.h
+++ b/sys/compat/mach/mach_bootstrap.h
@@ -1,4 +1,4 @@
-/*	$NetBSD: mach_bootstrap.h,v 1.5 2008/04/28 20:23:44 martin Exp $ */
+/*	$FreeBSD$ */
 
 /*-
  * Copyright (c) 2002 The NetBSD Foundation, Inc.
diff --git a/sys/compat/mach/mach_clock.c b/sys/compat/mach/mach_clock.c
index d802315..f3c9fef 100644
--- a/sys/compat/mach/mach_clock.c
+++ b/sys/compat/mach/mach_clock.c
@@ -1,6 +1,7 @@
-/*	$NetBSD: mach_clock.c,v 1.19 2008/04/28 20:23:44 martin Exp $ */
+/*	$FreeBSD$ */
 
 /*-
+ * Copyright (c) 2014 Matthew Macy <kmacy@freebsd.org>
  * Copyright (c) 2002-2003 The NetBSD Foundation, Inc.
  * All rights reserved.
  *
@@ -30,7 +31,7 @@
  */
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: mach_clock.c,v 1.19 2008/04/28 20:23:44 martin Exp $");
+__FBSDID("$FreeBSD$");
 
 #include <sys/types.h>
 #include <sys/param.h>
@@ -45,10 +46,21 @@ __KERNEL_RCSID(0, "$NetBSD: mach_clock.c,v 1.19 2008/04/28 20:23:44 martin Exp $
 #include <compat/mach/mach_port.h>
 #include <compat/mach/mach_clock.h>
 #include <compat/mach/mach_services.h>
-#include <compat/mach/mach_syscallargs.h>
+#include <compat/mach/mach_proto.h>
+
+#define timespecsub_netbsd(tsp, usp, vsp)                               \
+        do {                                                            \
+                (vsp)->tv_sec = (tsp)->tv_sec - (usp)->tv_sec;          \
+                (vsp)->tv_nsec = (tsp)->tv_nsec - (usp)->tv_nsec;       \
+                if ((vsp)->tv_nsec < 0) {                               \
+                        (vsp)->tv_sec--;                                \
+                        (vsp)->tv_nsec += 1000000000L;                  \
+                }                                                       \
+        } while (/* CONSTCOND */ 0)
+
 
 int
-mach_sys_clock_sleep_trap(struct lwp *l, const struct mach_sys_clock_sleep_trap_args *uap, register_t *retval)
+sys_mach_clock_sleep_trap(struct thread *td, struct mach_clock_sleep_trap_args *uap)
 {
 	/* {
 		syscallarg(mach_clock_port_t) clock_name;
@@ -63,12 +75,12 @@ mach_sys_clock_sleep_trap(struct lwp *l, const struct mach_sys_clock_sleep_trap_
 	int error;
 	int ticks;
 
-	mts.tv_sec = SCARG(uap, sleep_sec);
-	mts.tv_nsec = SCARG(uap, sleep_nsec);
+	mts.tv_sec = uap->sleep_sec;
+	mts.tv_nsec = uap->sleep_nsec;
 
-	if (SCARG(uap, sleep_type) == MACH_TIME_ABSOLUTE) {
+	if (uap->sleep_type == MACH_TIME_ABSOLUTE) {
 		nanotime(&cts);
-		timespecsub(&mts, &cts, &tts);
+		timespecsub_netbsd(&mts, &cts, &tts);
 	} else {
 		tts.tv_sec = mts.tv_sec;
 		tts.tv_nsec = mts.tv_nsec;
@@ -79,11 +91,11 @@ mach_sys_clock_sleep_trap(struct lwp *l, const struct mach_sys_clock_sleep_trap_
 
 	tsleep(&dontcare, PZERO|PCATCH, "sleep", ticks);
 
-	if (SCARG(uap, wakeup_time) != NULL) {
+	if (uap->wakeup_time != NULL) {
 		nanotime(&cts);
 		mcts.tv_sec = cts.tv_sec;
 		mcts.tv_nsec = cts.tv_nsec;
-		error = copyout(&mcts, SCARG(uap, wakeup_time), sizeof(mcts));
+		error = copyout(&mcts, uap->wakeup_time, sizeof(mcts));
 		if (error != 0)
 			return error;
 	}
@@ -92,7 +104,7 @@ mach_sys_clock_sleep_trap(struct lwp *l, const struct mach_sys_clock_sleep_trap_
 }
 
 int
-mach_sys_timebase_info(struct lwp *l, const struct mach_sys_timebase_info_args *uap, register_t *retval)
+sys_mach_timebase_info(struct thread *td, struct mach_timebase_info_args *uap)
 {
 	/* {
 		syscallarg(mach_timebase_info_t) info;
@@ -104,7 +116,7 @@ mach_sys_timebase_info(struct lwp *l, const struct mach_sys_timebase_info_args *
 	info.numer = 4000000000UL;
 	info.denom = 75189611UL;
 
-	if ((error = copyout(&info, (void *)SCARG(uap, info),
+	if ((error = copyout(&info, (void *)uap->info,
 	    sizeof(info))) != 0)
 		return error;
 
diff --git a/sys/compat/mach/mach_clock.h b/sys/compat/mach/mach_clock.h
index ea3584e..8347837 100644
--- a/sys/compat/mach/mach_clock.h
+++ b/sys/compat/mach/mach_clock.h
@@ -1,4 +1,4 @@
-/*	$NetBSD: mach_clock.h,v 1.8 2008/04/28 20:23:44 martin Exp $ */
+/*	$FreeBSD$ */
 
 /*-
  * Copyright (c) 2002-2003 The NetBSD Foundation, Inc.
diff --git a/sys/compat/mach/mach_errno.c b/sys/compat/mach/mach_errno.c
index 7e59e98..12919f65 100644
--- a/sys/compat/mach/mach_errno.c
+++ b/sys/compat/mach/mach_errno.c
@@ -1,4 +1,4 @@
-/*	$NetBSD: mach_errno.c,v 1.18 2008/04/28 20:23:44 martin Exp $ */
+/*	$FreeBSD$ */
 
 /*-
  * Copyright (c) 2002 The NetBSD Foundation, Inc.
@@ -30,11 +30,9 @@
  */
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: mach_errno.c,v 1.18 2008/04/28 20:23:44 martin Exp $");
 
 #include <sys/types.h>
 #include <sys/systm.h>
-#include <sys/null.h>
 #include <sys/queue.h>
 #include <sys/errno.h>
 
diff --git a/sys/compat/mach/mach_errno.h b/sys/compat/mach/mach_errno.h
index 8a45e5c..d9a54dc 100644
--- a/sys/compat/mach/mach_errno.h
+++ b/sys/compat/mach/mach_errno.h
@@ -1,4 +1,4 @@
-/*	$NetBSD: mach_errno.h,v 1.9 2008/04/28 20:23:44 martin Exp $ */
+/*	$FreeBSD$ */
 
 /*-
  * Copyright (c) 2002 The NetBSD Foundation, Inc.
diff --git a/sys/compat/mach/mach_exception.c b/sys/compat/mach/mach_exception.c
index 907e122..ffda2ef 100644
--- a/sys/compat/mach/mach_exception.c
+++ b/sys/compat/mach/mach_exception.c
@@ -1,5 +1,3 @@
-/*	$NetBSD: mach_exception.c,v 1.14 2009/03/14 21:04:18 dsl Exp $ */
-
 /*-
  * Copyright (c) 2003 The NetBSD Foundation, Inc.
  * All rights reserved.
@@ -30,20 +28,15 @@
  */
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: mach_exception.c,v 1.14 2009/03/14 21:04:18 dsl Exp $");
-
-#include "opt_compat_darwin.h"
+__FBSDID("$FreeBSD$");
 
 #include <sys/types.h>
 #include <sys/param.h>
 #include <sys/signal.h>
+#include <sys/systm.h>
 #include <sys/proc.h>
 #include <sys/malloc.h>
 
-#ifdef COMPAT_DARWIN
-#include <compat/darwin/darwin_exec.h>
-#endif
-
 #include <compat/mach/mach_types.h>
 #include <compat/mach/mach_exec.h>
 #include <compat/mach/mach_errno.h>
@@ -68,23 +61,23 @@ static void mach_siginfo_to_exception(const struct ksiginfo *, int *);
  * mach_trapinfo1 and handle signals if it gets a non zero return value.
  */
 void
-mach_trapsignal(struct lwp *l, struct ksiginfo *ksi)
+mach_trapsignal(struct thread *td, struct ksiginfo *ksi)
 {
-	if (mach_trapsignal1(l, ksi) != 0)
-		trapsignal(l, ksi);
+	if (mach_trapsignal1(td, ksi) != 0)
+		trapsignal(td, ksi);
 	return;
 }
 
 int
-mach_trapsignal1(struct lwp *l, struct ksiginfo *ksi)
+mach_trapsignal1(struct thread *td, struct ksiginfo *ksi)
 {
-	struct proc *p = l->l_proc;
+	struct proc *p = td->td_proc;
 	struct mach_emuldata *med;
 	int exc_no;
 	int code[2];
 
 	/* Don't inhinbit non maskable signals */
-	if (sigprop[ksi->ksi_signo] & SA_CANTMASK)
+	if (sigprop(ksi->ksi_signo) & SA_CANTMASK)
 		return EINVAL;
 
 	med = (struct mach_emuldata *)p->p_emuldata;
@@ -110,12 +103,12 @@ mach_trapsignal1(struct lwp *l, struct ksiginfo *ksi)
 
 	mach_siginfo_to_exception(ksi, code);
 
-	return mach_exception(l, exc_no, code);
+	return mach_exception(td, exc_no, code);
 }
 
 int
-mach_exception(struct lwp *exc_l, int exc, int *code)
-	/* exc_l:	 currently running lwp */
+mach_exception(struct thread *exc_td, int exc, int *code)
+	/* exc_td:	 currently running thread */
 {
 	int behavior, flavor;
 	mach_msg_header_t *msgh;
@@ -125,7 +118,7 @@ mach_exception(struct lwp *exc_l, int exc, int *code)
 	struct mach_lwp_emuldata *exc_mle;
 	struct mach_emuldata *catcher_med;
 	struct mach_right *kernel_mr;
-	struct lwp *catcher_l;	/* The lwp catching the exception */
+	struct thread *catcher_td;	/* The lwp catching the exception */
 	struct mach_right *exc_task;
 	struct mach_right *exc_thread;
 	struct mach_port *exc_port;
@@ -133,14 +126,14 @@ mach_exception(struct lwp *exc_l, int exc, int *code)
 	int error = 0;
 
 #ifdef DIAGNOSTIC
-	if (exc_l == NULL) {
-		printf("mach_exception: exc_l = %p\n", exc_l);
+	if (exc_td == NULL) {
+		printf("mach_exception: exc_td = %p\n", exc_td);
 		return ESRCH;
 	}
 #endif
 #ifdef DEBUG_MACH
 	printf("mach_exception: %d.%d, exc %d, code (%d, %d)\n",
-	    exc_l->l_proc->p_pid, exc_l->l_lid, exc, code[0], code[1]);
+	    exc_td->td_proc->p_pid, exc_td->td_lid, exc, code[0], code[1]);
 #endif
 
 	/*
@@ -148,24 +141,22 @@ mach_exception(struct lwp *exc_l, int exc, int *code)
 	 * the process at the time it dies.
 	 */
 	if (mach_exception_hang) {
-		struct proc *p = exc_l->l_proc;
+		struct proc *p = exc_td->td_proc;
 
-		sigminusset(&contsigmask, &exc_l->l_sigpendset->sp_set);
-		lwp_lock(exc_l);
+		sigminusset(&contsigmask, &exc_td->td_sigpendset->sp_set);
+		thread_lock(exc_td);
 		p->p_pptr->p_nstopchild++;
 		p->p_stat = SSTOP;
-		exc_l->l_stat = LSSTOP;
+		exc_td->td_stat = LSSTOP;
 		p->p_nrlwps--;
-		KERNEL_UNLOCK_ALL(exc_l, &exc_l->l_biglocks);
-		mi_switch(exc_l);
-		KERNEL_LOCK(exc_l->l_biglocks, exc_l);
+		mi_switch(exc_td);
 	}
 
 	/*
 	 * No exception if there is no exception port or if it has no receiver
 	 */
-	exc_mle = exc_l->l_emuldata;
-	exc_med = exc_l->l_proc->p_emuldata;
+	exc_mle = exc_td->td_emuldata;
+	exc_med = exc_td->td_proc->p_emuldata;
 	if ((exc_port = exc_med->med_exc[exc]) == NULL)
 		return EINVAL;
 
@@ -177,14 +168,14 @@ mach_exception(struct lwp *exc_l, int exc, int *code)
 
 #ifdef DEBUG_MACH
 	printf("catcher is %d.%d, state %d\n",
-	    exc_port->mp_recv->mr_lwp->l_proc->p_pid,
+	    exc_port->mp_recv->mr_lwp->td_proc->p_pid,
 	    exc_port->mp_recv->mr_lwp->l_lid,
-	    exc_port->mp_recv->mr_lwp->l_proc->p_stat);
+	    exc_port->mp_recv->mr_lwp->td_proc->p_stat);
 #endif
 	/*
 	 * Don't send exceptions to dying processes
 	 */
-	if (P_ZOMBIE(exc_port->mp_recv->mr_lwp->l_proc)) {
+	if (P_ZOMBIE(exc_port->mp_recv->mr_lwp->td_proc)) {
 		error = ESRCH;
 		goto out;
 	}
@@ -209,8 +200,8 @@ mach_exception(struct lwp *exc_l, int exc, int *code)
 	 * a dying parent, a signal is sent instead of the
 	 * notification, this fixes the problem.
 	 */
-	if ((exc_l->l_proc->p_slflag & PSL_TRACED) &&
-	    (exc_l->l_proc->p_pptr->p_sflag & PS_WEXIT)) {
+	if ((exc_td->td_proc->p_slflag & PSL_TRACED) &&
+	    (exc_td->td_proc->p_pptr->p_sflag & PS_WEXIT)) {
 #ifdef DEBUG_MACH
 		printf("mach_exception: deadlock avoided\n");
 #endif
@@ -233,22 +224,22 @@ mach_exception(struct lwp *exc_l, int exc, int *code)
 	 * We want the port names in the target process, that is,
 	 * the process with receive right for exc_port.
 	 */
-	catcher_l = exc_port->mp_recv->mr_lwp;
-	catcher_med = catcher_l->l_proc->p_emuldata;
-	exc_mr = mach_right_get(exc_port, catcher_l, MACH_PORT_TYPE_SEND, 0);
+	catcher_td = exc_port->mp_recv->mr_lwp;
+	catcher_med = catcher_td->td_proc->p_emuldata;
+	exc_mr = mach_right_get(exc_port, catcher_td, MACH_PORT_TYPE_SEND, 0);
 	kernel_mr = mach_right_get(catcher_med->med_kernel,
-	    catcher_l, MACH_PORT_TYPE_SEND, 0);
+	    catcher_td, MACH_PORT_TYPE_SEND, 0);
 
 	exc_task = mach_right_get(exc_med->med_kernel,
-	    catcher_l, MACH_PORT_TYPE_SEND, 0);
+	    catcher_td, MACH_PORT_TYPE_SEND, 0);
 	exc_thread = mach_right_get(exc_mle->mle_kernel,
-	    catcher_l, MACH_PORT_TYPE_SEND, 0);
+	    catcher_td, MACH_PORT_TYPE_SEND, 0);
 
 	switch (behavior) {
 	case MACH_EXCEPTION_DEFAULT: {
 		mach_exception_raise_request_t *req;
 
-		req = malloc(sizeof(*req), M_EMULDATA, M_WAITOK | M_ZERO);
+		req = malloc(sizeof(*req), M_MACH, M_WAITOK | M_ZERO);
 		msglen = sizeof(*req);
 		msgh = (mach_msg_header_t *)req;
 
@@ -277,7 +268,7 @@ mach_exception(struct lwp *exc_l, int exc, int *code)
 		mach_exception_raise_state_request_t *req;
 		int dc;
 
-		req = malloc(sizeof(*req), M_EMULDATA, M_WAITOK | M_ZERO);
+		req = malloc(sizeof(*req), M_MACH, M_WAITOK | M_ZERO);
 		msglen = sizeof(*req);
 		msgh = (mach_msg_header_t *)req;
 
@@ -293,7 +284,7 @@ mach_exception(struct lwp *exc_l, int exc, int *code)
 		req->req_codecount = 2;
 		memcpy(&req->req_code[0], code, sizeof(req->req_code));
 		req->req_flavor = flavor;
-		mach_thread_get_state_machdep(exc_l,
+		mach_thread_get_state_machdep(exc_td,
 		    flavor, req->req_state, &dc);
 
 		msglen = msglen -
@@ -308,7 +299,7 @@ mach_exception(struct lwp *exc_l, int exc, int *code)
 		mach_exception_raise_state_identity_request_t *req;
 		int dc;
 
-		req = malloc(sizeof(*req), M_EMULDATA, M_WAITOK | M_ZERO);
+		req = malloc(sizeof(*req), M_MACH, M_WAITOK | M_ZERO);
 		msglen = sizeof(*req);
 		msgh = (mach_msg_header_t *)req;
 
@@ -329,7 +320,7 @@ mach_exception(struct lwp *exc_l, int exc, int *code)
 		req->req_codecount = 2;
 		memcpy(&req->req_code[0], code, sizeof(req->req_code));
 		req->req_flavor = flavor;
-		mach_thread_get_state_machdep(exc_l,
+		mach_thread_get_state_machdep(exc_td,
 		    flavor, req->req_state, &dc);
 
 		msglen = msglen -
@@ -362,7 +353,7 @@ mach_exception(struct lwp *exc_l, int exc, int *code)
 	 */
 	if (((exc_port = exc_med->med_exc[exc]) == NULL) ||
 	    (exc_port->mp_recv == NULL) ||
-	    (P_ZOMBIE(exc_port->mp_recv->mr_lwp->l_proc))) {
+	    (P_ZOMBIE(exc_port->mp_recv->mr_lwp->td_proc))) {
 		error = ESRCH;
 		goto out;
 	}
@@ -376,12 +367,12 @@ mach_exception(struct lwp *exc_l, int exc, int *code)
 	 */
 #ifdef DEBUG_MACH
 	printf("mach_exception: %d.%d sleep on catcher_med->med_exclock = %p\n",
-	    exc_l->l_proc->p_pid, exc_l->l_lid, &catcher_med->med_exclock);
+	    exc_td->td_proc->p_pid, exc_td->td_lid, &catcher_med->med_exclock);
 #endif
 	error = tsleep(&catcher_med->med_exclock, PZERO, "mach_exc", 0);
 #ifdef DEBUG_MACH
 	printf("mach_exception: %d.%d resumed, error = %d\n",
-	    exc_l->l_proc->p_pid, exc_l->l_lid, error);
+	    exc_td->td_proc->p_pid, exc_td->td_lid, error);
 #endif
 
 	/*
@@ -470,7 +461,7 @@ mach_siginfo_to_exception(const struct ksiginfo *ksi, int *code)
 int
 mach_exception_raise(struct mach_trap_args *args)
 {
-	struct lwp *l = args->l;
+	struct thread *td = args->td;
 	mach_exception_raise_reply_t *rep;
 	struct mach_emuldata *med;
 
@@ -493,7 +484,7 @@ mach_exception_raise(struct mach_trap_args *args)
 	if (rep->rep_retval != 0)
 		return 0;
 
-	med = l->l_proc->p_emuldata;
+	med = td->td_proc->p_emuldata;
 
 	/*
 	 * Check for unexpected exception acknowledge, whereas
diff --git a/sys/compat/mach/mach_exception.h b/sys/compat/mach/mach_exception.h
index de1e630..6ab6ec9 100644
--- a/sys/compat/mach/mach_exception.h
+++ b/sys/compat/mach/mach_exception.h
@@ -152,9 +152,9 @@ struct mach_exc_info {
 	int mei_behavior;
 };
 
-void mach_trapsignal(struct lwp *, struct ksiginfo *);
-int mach_trapsignal1(struct lwp *, struct ksiginfo *);
-int mach_exception(struct lwp *, int, int *);
+void mach_trapsignal(struct thread *, struct ksiginfo *);
+int mach_trapsignal1(struct thread *, struct ksiginfo *);
+int mach_exception(struct thread *, int, int *);
 
 #endif /* _MACH_EXCEPTION_H_ */
 
diff --git a/sys/compat/mach/mach_exec.c b/sys/compat/mach/mach_exec.c
index ac46629..d2009b9 100644
--- a/sys/compat/mach/mach_exec.c
+++ b/sys/compat/mach/mach_exec.c
@@ -1,4 +1,4 @@
-/*	$NetBSD: mach_exec.c,v 1.74 2010/07/25 11:25:57 jym Exp $	 */
+/*	$FreeBSD$ */
 
 /*-
  * Copyright (c) 2001-2003 The NetBSD Foundation, Inc.
@@ -30,23 +30,17 @@
  */
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: mach_exec.c,v 1.74 2010/07/25 11:25:57 jym Exp $");
-
-#include "opt_syscall_debug.h"
+__FBSDID("$FreeBSD$");
 
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/proc.h>
 #include <sys/exec.h>
 #include <sys/queue.h>
-#include <sys/exec_macho.h>
 #include <sys/malloc.h>
 
+#include <sys/sysent.h>
 #include <sys/syscall.h>
-#include <sys/syscallvar.h>
-
-#include <uvm/uvm_extern.h>
-#include <uvm/uvm_param.h>
 
 #include <compat/mach/mach_types.h>
 #include <compat/mach/mach_message.h>
@@ -125,7 +119,7 @@ struct emul emul_mach = {
  * emulation, and it probably contains Darwin specific bits.
  */
 int
-exec_mach_copyargs(struct lwp *l, struct exec_package *pack, struct ps_strings *arginfo, char **stackp, void *argp)
+exec_mach_copyargs(struct thread *l, struct exec_package *pack, struct ps_strings *arginfo, char **stackp, void *argp)
 {
 	struct exec_macho_emul_arg *emea;
 	struct exec_macho_object_header *macho_hdr;
@@ -189,7 +183,7 @@ mach_e_proc_exec(struct proc *p, struct exec_package *epp)
 	mach_e_proc_init(p);
 
 	if (p->p_emul != epp->ep_esch->es_emul) {
-		struct lwp *l = LIST_FIRST(&p->p_lwps);
+		struct thread *l = LIST_FIRST(&p->p_lwps);
 		KASSERT(l != NULL);
 		mach_e_lwp_fork(NULL, l);
 	}
@@ -198,14 +192,14 @@ mach_e_proc_exec(struct proc *p, struct exec_package *epp)
 }
 
 void
-mach_e_proc_fork(struct proc *p2, struct lwp *l1, int forkflags)
+mach_e_proc_fork(struct proc *p2, struct thread *l1, int forkflags)
 {
 	mach_e_proc_fork1(p2, l1, 1);
 	return;
 }
 
 void
-mach_e_proc_fork1(struct proc *p2, struct lwp *l1, int allocate)
+mach_e_proc_fork1(struct proc *p2, struct thread *l1, int allocate)
 {
 	struct mach_emuldata *med1;
 	struct mach_emuldata *med2;
@@ -221,7 +215,7 @@ mach_e_proc_fork1(struct proc *p2, struct lwp *l1, int allocate)
 	mach_e_proc_init(p2);
 
 	med1 = p2->p_emuldata;
-	med2 = l1->l_proc->p_emuldata;
+	med2 = td1->td_proc->p_emuldata;
 
 	/*
 	 * Exception ports are inherited between forks,
@@ -267,7 +261,7 @@ mach_e_proc_init(struct proc *p)
 			printf("mach_emuldata allocated for non Mach binary\n");
 #endif
 		p->p_emuldata = malloc(sizeof(struct mach_emuldata),
-		    M_EMULDATA, M_WAITOK | M_ZERO);
+		    M_MACH, M_WAITOK | M_ZERO);
 	}
 
 	med = (struct mach_emuldata *)p->p_emuldata;
@@ -347,7 +341,7 @@ mach_e_proc_exit(struct proc *p)
 {
 	struct mach_emuldata *med;
 	struct mach_right *mr;
-	struct lwp *l;
+	struct thread *l;
 	int i;
 
 	/* There is only one lwp remaining... */
@@ -391,18 +385,18 @@ mach_e_proc_exit(struct proc *p)
 
 	rw_destroy(&med->med_exclock);
 	rw_destroy(&med->med_rightlock);
-	free(med, M_EMULDATA);
+	free(med, M_MACH);
 	p->p_emuldata = NULL;
 
 	return;
 }
 
 void
-mach_e_lwp_fork(struct lwp *l1, struct lwp *l2)
+mach_e_lwp_fork(struct thread *l1, struct thread *l2)
 {
 	struct mach_lwp_emuldata *mle;
 
-	mle = malloc(sizeof(*mle), M_EMULDATA, M_WAITOK);
+	mle = malloc(sizeof(*mle), M_MACH, M_WAITOK);
 	l2->l_emuldata = mle;
 
 	mle->mle_kernel = mach_port_get();
@@ -421,7 +415,7 @@ mach_e_lwp_fork(struct lwp *l1, struct lwp *l2)
 }
 
 void
-mach_e_lwp_exit(struct lwp *l)
+mach_e_lwp_exit(struct thread *l)
 {
 	struct mach_lwp_emuldata *mle;
 
@@ -439,7 +433,7 @@ mach_e_lwp_exit(struct lwp *l)
 	mle->mle_kernel->mp_datatype = MACH_MP_NONE;
 	MACH_PORT_UNREF(mle->mle_kernel);
 
-	free(mle, M_EMULDATA);
+	free(mle, M_MACH);
 	l->l_emuldata = NULL;
 
 	return;
diff --git a/sys/compat/mach/mach_exec.h b/sys/compat/mach/mach_exec.h
index 06a8914..28674f1 100644
--- a/sys/compat/mach/mach_exec.h
+++ b/sys/compat/mach/mach_exec.h
@@ -1,4 +1,4 @@
-/*	$NetBSD: mach_exec.h,v 1.35 2011/03/05 23:51:47 joerg Exp $	 */
+/*	$FreeBSD$ */
 
 /*-
  * Copyright (c) 2001 The NetBSD Foundation, Inc.
@@ -31,8 +31,8 @@
 
 #ifndef	_MACH_EXEC_H_
 #define	_MACH_EXEC_H_
-
-#include <uvm/uvm_extern.h>
+#include <sys/lock.h>
+#include <sys/rwlock.h>
 
 #include <compat/mach/mach_types.h>
 #include <compat/mach/mach_message.h>
@@ -44,7 +44,7 @@ struct mach_emuldata {
 	int med_inited;			/* Is this structure initialized? */
 	int med_thpri;			/* Saved priority */
 	LIST_HEAD(med_right, mach_right) med_right;
-	krwlock_t med_rightlock;	/* process right list and lock */
+	struct rwlock med_rightlock;	/* process right list and lock */
 	mach_port_t med_nextright;	/* next unused right */
 
 	struct mach_port *med_bootstrap;/* task bootstrap port */
@@ -54,24 +54,24 @@ struct mach_emuldata {
 
 	int med_dirty_thid;		/* Thread id not yet initialized */
 	int med_suspend;		/* Suspend semaphore */
-	krwlock_t med_exclock;		/* Process exception handler lock */
+	struct rwlock med_exclock;		/* Process exception handler lock */
 };
 
-struct mach_lwp_emuldata {
+struct mach_thread_emuldata {
 	struct mach_port *mle_kernel;	/* Thread's kernel port */
 };
 
 struct ps_strings;
-int exec_mach_copyargs(struct lwp *, struct exec_package *,
+int exec_mach_copyargs(struct thread *, struct exec_package *,
     struct ps_strings *, char **, void *);
 int exec_mach_probe(const char **);
 void mach_e_proc_init(struct proc *);
 void mach_e_proc_exit(struct proc *);
 void mach_e_proc_exec(struct proc *, struct exec_package *);
-void mach_e_proc_fork(struct proc *, struct lwp *, int);
-void mach_e_proc_fork1(struct proc *, struct lwp *, int);
-void mach_e_lwp_fork(struct lwp *, struct lwp *);
-void mach_e_lwp_exit(struct lwp *);
+void mach_e_proc_fork(struct proc *, struct thread *, int);
+void mach_e_proc_fork1(struct proc *, struct thread *, int);
+void mach_e_lwp_fork(struct thread *, struct thread *);
+void mach_e_lwp_exit(struct thread *);
 
 extern struct emul emul_mach;
 
diff --git a/sys/compat/mach/mach_host.c b/sys/compat/mach/mach_host.c
index 767348c..c9b7ffc 100644
--- a/sys/compat/mach/mach_host.c
+++ b/sys/compat/mach/mach_host.c
@@ -1,5 +1,3 @@
-/*	$NetBSD: mach_host.c,v 1.31 2008/04/28 20:23:44 martin Exp $ */
-
 /*-
  * Copyright (c) 2002-2003 The NetBSD Foundation, Inc.
  * All rights reserved.
@@ -30,7 +28,7 @@
  */
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: mach_host.c,v 1.31 2008/04/28 20:23:44 martin Exp $");
+__FBSDID("$FreeBSD$");
 
 #include <sys/types.h>
 #include <sys/malloc.h>
@@ -40,9 +38,6 @@ __KERNEL_RCSID(0, "$NetBSD: mach_host.c,v 1.31 2008/04/28 20:23:44 martin Exp $"
 #include <sys/signal.h>
 #include <sys/proc.h>
 
-#include <uvm/uvm_extern.h>
-#include <uvm/uvm_param.h>
-
 #include <compat/mach/mach_types.h>
 #include <compat/mach/mach_host.h>
 #include <compat/mach/mach_port.h>
@@ -144,10 +139,10 @@ mach_host_get_clock_service(struct mach_trap_args *args)
 	mach_host_get_clock_service_request_t *req = args->smsg;
 	mach_host_get_clock_service_reply_t *rep = args->rmsg;
 	size_t *msglen = args->rsize;
-	struct lwp *l = args->l;
+	struct thread *td = args->td;
 	struct mach_right *mr;
 
-	mr = mach_right_get(mach_clock_port, l, MACH_PORT_TYPE_SEND, 0);
+	mr = mach_right_get(mach_clock_port, td, MACH_PORT_TYPE_SEND, 0);
 
 	*msglen = sizeof(*rep);
 	mach_set_header(rep, req, *msglen);
@@ -179,10 +174,10 @@ mach_host_get_io_master(struct mach_trap_args *args)
 	mach_host_get_io_master_request_t *req = args->smsg;
 	mach_host_get_io_master_reply_t *rep = args->rmsg;
 	size_t *msglen = args->rsize;
-	struct lwp *l = args->l;
+	struct thread *td = args->td;
 	struct mach_right *mr;
 
-	mr = mach_right_get(mach_io_master_port, l, MACH_PORT_TYPE_SEND, 0);
+	mr = mach_right_get(mach_io_master_port, td, MACH_PORT_TYPE_SEND, 0);
 
 	*msglen = sizeof(*rep);
 	mach_set_header(rep, req, *msglen);
@@ -198,12 +193,12 @@ mach_processor_set_default(struct mach_trap_args *args)
 	mach_processor_set_default_request_t *req = args->smsg;
 	mach_processor_set_default_reply_t *rep = args->rmsg;
 	size_t *msglen = args->rsize;
-	struct lwp *l = args->l;
+	struct thread *td = args->td;
 	struct mach_right *mr;
 	struct mach_port *mp;
 
 	mp = mach_port_get();
-	mr = mach_right_get(mp, l, MACH_PORT_TYPE_SEND, 0);
+	mr = mach_right_get(mp, td, MACH_PORT_TYPE_SEND, 0);
 
 	*msglen = sizeof(*rep);
 	mach_set_header(rep, req, *msglen);
@@ -219,18 +214,18 @@ mach_host_processor_set_priv(struct mach_trap_args *args)
 	mach_host_processor_set_priv_request_t *req = args->smsg;
 	mach_host_processor_set_priv_reply_t *rep = args->rmsg;
 	size_t *msglen = args->rsize;
-	struct lwp *l = args->l;
+	struct thread *td = args->td;
 	mach_port_t mn;
 	struct mach_right *mr;
 	struct mach_right *smr;
 	struct mach_port *smp;
 
 	mn = req->req_set.name;
-	if ((mr = mach_right_check(mn, l, MACH_PORT_TYPE_ALL_RIGHTS)) == NULL)
+	if ((mr = mach_right_check(mn, td, MACH_PORT_TYPE_ALL_RIGHTS)) == NULL)
 		return mach_msg_error(args, EINVAL);
 
 	smp = mach_port_get();
-	smr = mach_right_get(smp, l, MACH_PORT_TYPE_SEND, 0);
+	smr = mach_right_get(smp, td, MACH_PORT_TYPE_SEND, 0);
 
 	*msglen = sizeof(*rep);
 	mach_set_header(rep, req, *msglen);
diff --git a/sys/compat/mach/mach_host.h b/sys/compat/mach/mach_host.h
index ed57c90..abbab10 100644
--- a/sys/compat/mach/mach_host.h
+++ b/sys/compat/mach/mach_host.h
@@ -1,4 +1,4 @@
-/*	$NetBSD: mach_host.h,v 1.17 2008/04/28 20:23:44 martin Exp $ */
+/*	$FreeBSD$ */
 
 /*-
  * Copyright (c) 2002-2003 The NetBSD Foundation, Inc.
